#library(MASS)
#diry = "C:/Users/Sangwon/Dropbox/CMU/CURRENT courses/JournalClub/MyNotes/Knockoff/"
#setwd(diry)
#source('funs.R')

n = 300
p = 100
k = 30

set.seed(3)

### Beta is fixed in our single model
#signal_beta = c()
#for(ki in 1:k)   signal_beta = c(signal_beta, (if(runif(1,0,1)>0.5) 3.5 else -3.5))
#beta = rep(0,p)
#beta[1:k] = signal_beta #beta[sample(1:1000, 30)] <- signal_beta


observed_FDR = numeric(100)





# loop through each setting of the signal

for(b in c(2)){#
  cat("b: ",b,fill=TRUE)
  ## Beta is fixed in our single model
  signal_beta = c()
  for(ki in 1:k)   signal_beta = c(signal_beta, (if(runif(1,0,1)>0.5) b else b))
  beta = rep(0,p)
  beta[1:k] = signal_beta #beta[sample(1:1000, 30)] <- signal_beta
  

FDRs = c()
powers = c()


#for each run, devise 100
for(runs_i in 1:100){
cat("run: ", runs_i, fill=TRUE)
  
x = matrix(nrow = n, ncol = p)
for(irow in 1:n){
  for(icol in 1:p){
    x[irow, icol] = rnorm(1,0,1)
  }
}

colsize = sapply(1:p, function(j) sqrt(sum(x[,j]^2)) ,simplify = "array")
x = scale(x, center= FALSE, scale = colsize)

noise = rnorm(n=n,mean=0,sd=1)
y = x%*%beta + noise



X = data.frame(x)
lmfit = lm(y~.,data=X)
summ <- summary(lmfit)
pvals = summ$coefficients[,4][-1]
orderInds = order(pvals)

FDRControlLevel=0.2

largestK = 0
for(pind in 1:100){
    pval = pvals[orderInds[pind]]
    BHval = (pind/100)*FDRControlLevel
    if(pval<=BHval){
        largestK = pind
    }
}

selectedInds = orderInds[1:largestK]

FDR = sum(selectedInds>30)/max(length(selectedInds),1)
power = sum(selectedInds<=30)/30

FDRs = c(FDRs,FDR)
powers = c(powers,power)







}


pdf(paste0("LM-BH_",b,".pdf"), height = 7, width = 14)
  par(mfrow = c(1,2))
  hist(FDRs, main = paste0("FDR from simulations \n n=300,p=100 \n k=30,b=",b), col = 'skyblue')
  abline(v = mean(FDRs, na.rm=T), col = 'red', lwd = 2)
  legend("topleft", col='red', lwd = 2, legend = round(mean(FDRs,na.rm=T),3))
  
  hist(powers,main = paste0("Power from simulations \n n=300,p=100 \n k=30,b=",b), col = 'skyblue')
  abline(v = mean(powers,na.rm=T), col = 'red', lwd = 2)
  legend("topleft", col='red', lwd = 2, legend = round(mean(powers,na.rm=T),3))
dev.off()
line <- readline()  #pause until enter is hit



}
