blist = c(1,2,5,10,20)

pdf("trends.pdf", height = 7, width = 14)
par(mfrow = c(1,2))
fdr_list_Knockoff = c(.31,.157, .202, .232, .199)
fdr_list_Knockoffplus = c(.318, .606, .179, .202, .183)
fdr_list_BHq = c(.351, .154, .142, .127, .127)
fdr_list_FS = c(.322,.211,.314,.34,.056)
fdr_mat = cbind(fdr_list_Knockoff,
                fdr_list_Knockoffplus,
                fdr_list_BHq, fdr_list_FS)
matplot(fdr_mat, type = 'o', lty = c(1,1,1,1), lwd = 2, col = 1:4, pch = 2, main = "FDR Comparison", xlab = "signal strength", ylab = "FDR (avg 100 runs)")
legend("topright", col = 1:4, lwd=c(2,2,2,2), legend = c("knockoff", "knockoff+", "BHq_LS","FS"))
abline(h = .2, col = 'lightgrey', lty=2, lwd=2)



plist_k = c(.058,.235, .966, .992, .992)
plist_kp = c(.014, .745, .962,.993, .994)
plist_BHq = c(.036, .234, .987, 1, 1)
plist_FS = c(.117,.233,.986,1,1)
p_mat = cbind(plist_k,
              plist_kp,
              plist_BHq,plist_FS)

matplot(p_mat, type = 'o', lty = c(1,1,1,1), lwd = 2, col = 1:4, pch = 2, main = "Power Comparison", xlab = "signal strength", ylab = "Power (avg 100 runs)")
legend("bottomright", col = 1:4, lwd=c(2,2,2,2), legend = c("knockoff", "knockoff+", "BHq_LS","FS"))
dev.off()